//DualMicroBlasters.cs

//trail
datablock ParticleData(DualMicroBlastersTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 60;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "1 0.4 0.1 1";
	colors[1]	= "1 0.2 0.0 1";
	sizes[0]	= 0.10;
	sizes[1]	= 0.15;
	//times[0]	= 0.5;
	//times[1]	= 0.5;
};

datablock ParticleEmitterData(DualMicroBlastersTrailEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = DualMicroBlastersTrailParticle;

   useEmitterColors = true;
   uiName = "";
};


//muzzle flash effects
datablock ParticleData(DualMicroBlastersFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0.0 0.0 0.9";
	colors[1]     = "0.6 0.3 0.0 0.0";
	sizes[0]      = 0.1;
	sizes[1]      = 0.3;

	useInvAlpha = false;
};
datablock ParticleEmitterData(DualMicroBlastersFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "DualMicroBlastersFlashParticle";

   uiName = "";
};


datablock ExplosionData(DualMicroBlastersExplosion)
{
   //explosionShape = "";
	soundProfile = LaserHitSound;

   lifeTimeMS = 150;

   particleEmitter = LaserExplosionEmitter;
   particleDensity = 9;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 2;
   lightStartColor = "1 0.1 0.0";
   lightEndColor = "0 0 0";
};


AddDamageType("DualMicroBlasters",   '<bitmap:add-ons/Weapon_DualMicroBlasters/CI_DualMicroBlasters> %1',    '%2 <bitmap:add-ons/Weapon_DualMicroBlasters/CI_DualMicroBlasters> %1',0.2,1);
datablock ProjectileData(DualMicroBlastersProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 7;
   directDamageType    = $DamageType::DualMicroBlasters;
   radiusDamageType    = $DamageType::DualMicroBlasters;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 100;
   verticalImpulse	  = 100;
   explosion           = DualMicroBlastersExplosion;
   particleEmitter     = DualMicroBlastersTrailEmitter;

   muzzleVelocity      = 85;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = True;
   lightRadius = 2.0;
   lightColor  = ".9 0.3 0";

   uiName = "Dual Micro Blasters Laser";
};

//////////
// item //
//////////
datablock ItemData(DualMicroBlastersItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./DualMicroBlasters.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Dual Micro Blasters";
	iconName = "./icon_DualMicroBlasters";
	doColorShift = false;
	colorShiftColor = "1 1 1 1.000";

	 // Dynamic properties defined by the scripts
	image = DualMicroBlastersImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(DualMicroBlastersImage)
{
   // Basic Item properties
   shapeFile = "./DualMicroBlasters.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = DualMicroBlastersProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = False;
   colorShiftColor = DualMicroBlastersItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.2;
	stateSequence[0] = "ready";

	stateName[1] = "Ready";
	stateSequence[1] = "ready";
	stateTransitionOnTriggerDown[1] = "Fire";

	stateName[2] = "Fire";
	stateSequence[2] = "Fire";
	stateTransitionOnTimeout[2] = "Reload";
   	stateWaitForTimeout[2] = true;
	stateTimeoutValue[2] = 0.25;
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";
	stateSound[2] = LaserShotSound;
   	stateEmitter[2]					= DualMicroBlastersFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";

	stateName[3] = "Reload";
	stateAllowImageChange[3] = false;
	stateTransitionOnTriggerUp[3] = "FireDualMicro";
	stateSequence[3] = "ready";

	stateName[4] = "FireDualMicro";
	stateTimeoutValue[4] = 0.09;
	stateScript[4] = "onFireDualMicro";
	stateTransitionOnTimeOut[4] = "ready";
};


function DualMicroBlastersImage::onFireDualMicro(%this,%obj,%slot)
{
   %obj.setImageTrigger(1,1);
}


datablock ShapeBaseImageData(LeftDualMicroBlastersImage)
{
   // Basic Item properties
   shapeFile = "./DualMicroBlasters.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 1;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = DualMicroBlastersProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = false;

   doColorShift = False;
   //colorShiftColor = AkimboGunItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.2;
	stateSequence[0] = "ready";
   stateSound[0]		= weaponSwitchSound;

	stateName[1] = "Ready";
	stateSequence[1] = "ready";
	stateTransitionOnTriggerDown[1] = "Fire";

	stateName[2] = "Fire";
	stateSequence[2] = "Fire";
	stateTransitionOnTimeout[2] = "Reload";
   stateWaitForTimeout[2] = true;
	stateTimeoutValue[2] = 0.15;
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";
	stateSound[2] = LaserShotSound;
   stateEmitter[2]					= DualMicroBlastersFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";

	stateName[3] = "Reload";
	stateAllowImageChange[3] = false;
	stateTransitionOnTriggerUp[3] = "Ready";
	stateSequence[3] = "ready";


};

function LeftDualMicroBlastersImage::onFire(%this, %obj, %slot)
{
   Parent::onFire(%this,%obj,%slot);
   if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, leftrecoil);
}

function DualMicroBlastersImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   //mount lefthanded gun
   %obj.mountImage(LeftDualMicroBlastersImage, 1);
   //%obj.playThread(0, armreadyboth);
}
function DualMicroBlastersImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
   //unmount lefthanded gun
   %obj.unMountImage(1);
   //%obj.playThread(0, root);
}


function LeftDualMicroBlastersImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   %obj.playThread(1, armreadyboth);
}
function LeftDualMicroBlastersImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
}

function DualMicroBlastersImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftAway);
	Parent::onFire(%this,%obj,%slot);	

   //%obj.setImageTrigger(1,1);
}

